////////////////////////////////////////////////////////////////////////////
//
//  Nbv{[htbN
//
////////////////////////////////////////////////////////////////////////////


#include "UltraRC4Plugin.h"



static HHOOK hHook;
static DWORD nCurProcessID;
static HWND hDefWnd;
static WNDPROC DefWndProc;
static char* szPrevClipText; // ÕNbv{[he


static LRESULT CALLBACK CallWndProc(int nCode, WPARAM wp, LPARAM lp);
static LRESULT CALLBACK HookWindowProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp);


/* ------------------------------------------------------------------------------------------------------
	EBhEvV[WtbNJn
------------------------------------------------------------------------------------------------------ */
void BeginHook(HINSTANCE hInstance)
{
	if( hHook || DefWndProc ) return;
	nCurProcessID = GetCurrentProcessId();
	hHook = SetWindowsHookEx(WH_CALLWNDPROC, CallWndProc, hInstance, 0);
	LOG("BeginHook\n");
}

/* ------------------------------------------------------------------------------------------------------
	EBhEvV[WtbNI
------------------------------------------------------------------------------------------------------ */
void EndHook(void)
{
	if( DefWndProc ) SetWindowLong(hDefWnd, GWL_WNDPROC, (LONG)(LONG_PTR)DefWndProc);
	if( hHook ) UnhookWindowsHookEx( hHook );
	delete [] szPrevClipText;
	hHook = NULL;
	DefWndProc = NULL;
	hDefWnd = NULL;
	szPrevClipText = NULL;
	nCurProcessID = 0;
	LOG("EndHook\n");
}

/* ------------------------------------------------------------------------------------------------------
	tbNvV[W
------------------------------------------------------------------------------------------------------ */
static LRESULT CALLBACK CallWndProc(int nCode, WPARAM wp, LPARAM lp)
{
	CWPSTRUCT* cwp = (CWPSTRUCT*)lp;
	BOOL isCurThread = (BOOL)( wp != 0 );

	if( nCode < 0 )
		return CallNextHookEx(hHook, nCode, wp, lp);

	DWORD nProcessID=0;
	GetWindowThreadProcessId(cwp->hwnd, &nProcessID);

	if( nCode != HC_ACTION || cwp->message != WM_DRAWCLIPBOARD || nCurProcessID != nProcessID )
		return CallNextHookEx(hHook, nCode, wp, lp);

	// tbNŊĎĂEBhEłTuNXB
	//
	// CallNextHookEx()𖳎ĂWM_DRAWCLIPBOARDĂ܂BPostĂH
	// tbNŊĎEBhE聨TuNXăvV[W̏㏑̂Qi\őΉ
	if( !DefWndProc )
	{
		DefWndProc = (WNDPROC)(LONG_PTR)SetWindowLong(cwp->hwnd, GWL_WNDPROC, (LONG)(LONG_PTR)HookWindowProc);
		hDefWnd = cwp->hwnd;
		LOG("Begin subclass\n");
	}

	return CallNextHookEx(hHook, nCode, wp, lp);
}

/* ------------------------------------------------------------------------------------------------------
	TuNXvV[W
------------------------------------------------------------------------------------------------------ */
static LRESULT CALLBACK HookWindowProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp)
{
	BOOL isReturnNext=TRUE;

	// tbN
	if( hHook ) UnhookWindowsHookEx( hHook );
	hHook = NULL;

	if( msg != WM_DRAWCLIPBOARD )
		return CallWindowProc(DefWndProc, hwnd, msg, wp, lp);

	char szExePath[MAX_PATH]="";
	char* szExeFile;
	HWND hOwner = GetClipboardOwner();
	if( hOwner )
	{
		GetWindowModuleFileName(hOwner, szExePath, sizeof(szExePath));
		szExeFile = PathFindFileName( szExePath );
		if( stricmp("vncviewer.exe",szExeFile)==0 || stricmp("winvnc.exe",szExeFile)==0 )
			isReturnNext = FALSE;
		LOG("WM_DRAWCLIPBOARD %s %d\n",szExeFile,isReturnNext);
	}
/*
	BOOL ret = OpenClipboard( hwnd );
	do
	{
		if( !ret ) break;
		HANDLE hClip = GetClipboardData( CF_TEXT );
		if( !hClip ) break;
		// Nbv{[h擾
		char* szClipText = (char*)GlobalLock( hClip );
		size_t nClipSize = GlobalSize( hClip );
		// O̓eƓ
		if( szClipText && szPrevClipText && strcmp(szClipText, szPrevClipText)==0 )
		{
			// ꍇ͒ʒmȂ
			isReturnNext = FALSE;
			LOG("WM_DRAWCLIPBOARD No change\n");
		}
		else if( szClipText==NULL && szPrevClipText==NULL )
		{
			isReturnNext = FALSE;
			LOG("WM_DRAWCLIPBOARD No change\n");
		}
		else
		{
			// Ⴄꍇ͓eۑ
			delete [] szPrevClipText;
			szPrevClipText = NULL;
			if( szClipText )
			{
				szPrevClipText = new char [ nClipSize+1 ];
				if( szPrevClipText )
					strcpy(szPrevClipText, szClipText);
				LOG("WM_DRAWCLIPBOARD change\n");
			}
		}
		GlobalUnlock( hClip );
	} while(0);

	if( ret )
		CloseClipboard();
*/
	return isReturnNext ? CallWindowProc(DefWndProc, hwnd, msg, wp, lp) : 0;

}