/////////////////////////////////////////////////////////////////////////////
//  Copyright (C) 2002 Ultr@VNC. All Rights Reserved.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//  USA.
//
// If the source code for the program is not available from the place from
// which you received this file, check 
// http://ultravnc.sourceforge.net/
//
////////////////////////////////////////////////////////////////////////////
//
// IF YOU USE THIS GPL SOURCE CODE TO MAKE YOUR DSM PLUGIN, PLEASE ADD YOUR
// COPYRIGHT TO THE TOP OF THIS FILE AND SHORTLY DESCRIBE/EXPLAIN THE 
// MODIFICATIONS YOU'VE MADE. THANKS.
//
// IF YOU DON'T USE THIS CODE AS A BASE FOR YOUR PLUGIN, THE HEADER ABOVE AND
// ULTR@VNC COPYRIGHT SHOULDN'T BE FOUND IN YOUR PLUGIN SOURCE CODE.
//
////////////////////////////////////////////////////////////////////////////
//
// UltraRC4Plugin - RC4ÍvOC
// 
// Copyright(C) 2009-2013 K_Yaguchi.
// All rights reserved.
//
// vnco[WF Ultra@VNC v1.0.8.0
//                 Ultra@VNC v1.1.8.8
// JFWindows Vista UlȂƂ(32bit) @ VisualStudio2005(VS8.0)
//           Windows 7 Ultimate(64bit) @ VisualStudio2005(VS8.0) 64bitŃRpC
//
// ֐Ȃǂ͓̐ƎŒeł蓮ۏ؂̂ł͂܂B
//
//
// 2009.11.29 - v1.0.0
// 2013.04.08 - v1.0.0 64bit
//
//
// << m̕s >>
// {vOCNł͂Ȃ
//   փoO񍐂Ă̂邩܂B
//
// ETransformBuffer()nDataLenŗB
//   ڍׂ͊֐ɋLqB
//
// ENbv{[hRBi2013.04.08 v1.1.8.8ōČȂ̂ŋ炭ς݁j
//   vOCȂłČB
//   viewerڑApX[h͉ʂoԂŉ炩̕Rs[ƁA
//   F؂ĂȂ̂ɃNbv{[h̃f[^T[o[ɑĂ܂F؃G[ɂȂBȂƂRsy΍B
//
//////////////////////////////////////////////////////////////////////////////

#include "UltraRC4Plugin.h"





// Plugin Description
// Please use the following format (with ',' (comma) as separator)
// Name-Description,Author,Date,Version,FileName-Comment
// For the version, we recommend the following format: x.y.z
// The other fields (Name-Description, Author, Date, FileName-Comment) are format free (don't use ',' in them, of course)
//
//  Plugin ̃VOl` ( J}؂ )
// `: O,,t,o[W,t@C
// o[W'X.X.X'\Lł邱
#define PLUGIN_DESCRIPTION  "UltraRC4Plugin64,K_Yaguchi,Apr 08 2013,1.0.0,UltraRC4Plugin64.dsm"








static HINSTANCE hInstance;       // DLLCX^X

static PLGBUFFER TransBuffer={0};     // Transformpobt@
static PLGBUFFER RestBuffer={0};      // Restorepobt@
static RC4STATE  rc4Trans={0};        // 
static RC4STATE  rc4Rest={0};         // 
static BYTE pKeyData[URC4KEYLEN]={0}; // t@Cf[^
static char szExtKey[256]="";         // pX[h
static char szCurDir[MAX_PATH]="";    // W[̏ꏊ
static char szLogFile[MAX_PATH]="";   // ÕpX
static char szKeyFile[MAX_PATH]="";   // ̃pX

//static HWND hClipWnd; // Nbv{[hĎpEBhE





static BOOL PluginReadKeyFile(BYTE* pBuffer);





// fobOOo
void outlog(const char* str, ...)
{
	CProcessLock pl;
	char szExe[MAX_PATH]="";
	va_list argp;

	GetModuleFileName(NULL, szExe, sizeof(szExe));

	pl.Enter();
	FILE* out = fopen(szLogFile, "a");
	if( out )
	{
		va_start(argp, str);
		fprintf(out, "%-20s ", PathFindFileName(szExe));
		vfprintf(out, str, argp);
		va_end(argp);
		fclose(out);
	}
	pl.Leave();
}

void outbin(const BYTE* pData, int nSize, int nType)
{
	CProcessLock pl;
	char szExe[MAX_PATH]="";

	GetModuleFileName(NULL, szExe, sizeof(szExe));
	strcat(szExe,nType?".T":".R");

	pl.Enter();
	FILE* out = fopen(szExe, "a");
	if( out )
	{
		fwrite(pData, sizeof(BYTE), nSize, out);
		fclose(out);
	}
	pl.Leave();
}








// ----------------------------------------------------------------------
//
// A VNC DSM Plugin MUST export (extern "C" (__cdecl)) all the following
// functions (same names, same signatures)
//
// For return values, the rule is:
//    < 0, 0, and NULL pointer mean Error
//    > 0 and pointer != NULL mean Ok
//
// ֐ɂOK肪0ȏゾ1ȏゾ肷̂ŁAOK͂Ƃ肠1ȏԂ
//
// ----------------------------------------------------------------------
//

// ----------------------------------------------------------------------
// Returns the ID string of the Plugin
//
// yz
// vOC̃VOl`B
// viewer̃^CgȂ񂩂ɎgB
//
// yz
// Ȃ
//
// y߂lz
// vOC̃VOl` ( `: O,,t,o[W,t@C )
// ----------------------------------------------------------------------
PLUGIN_API char* Description(void)
{
	LOG("Description %s\n",PLUGIN_DESCRIPTION);
	return PLUGIN_DESCRIPTION;
}


// ------------------------------------------------------------------------------------------------------
// Initialize the plugin and all its internals
// Return -1 if error
//
// yz
// ֐B
// [hAꔭڂɌĂ΂Ƃ͌Ȃ̂ŒӁB
// ܂AShutdown()Ƒ΂̊֌Wł܂BStartup()͉xĂ΂ꍇ܂B
// viewer͐ڑɂP񂾂BRtBOʂJł͌Ă΂ȂB
// server͋N̂PƁAڑȂꍇ̓RtBOʂĂяoтɌĂ΂B
// ڑꍇ̓RtBOʂJł͌Ă΂ȂB
//
// yz
// Ȃ
//
// y߂lz
// >=0  I
// <0   G[
// ------------------------------------------------------------------------------------------------------
PLUGIN_API int Startup(void)
{
	szExtKey[0] = '\0';

	// f[^ǂݍ
	BOOL ret = PluginReadKeyFile( pKeyData );
	if( !ret ) memset(pKeyData, 0, sizeof(BYTE)*URC4KEYLEN);
	// f[^
	rc4_setup(&rc4Trans, pKeyData, sizeof(pKeyData));
	rc4_setup(&rc4Rest , pKeyData, sizeof(pKeyData));

//	BeginHook( hInstance );

	LOG("Startup %u\n",ret);
	return 1;
}


// ------------------------------------------------------------------------------------------------------
// Stop and Clean up the plugin 
// Return -1 if error
//
// yz
// viewer̓ZbVIAserver̓T[oIɌĂ΂B
// FreeBuffer()Shutdown()::FreeLibrary()̏ԁB
// Startup()Ƃ͑΂̊֌Wł͂Ȃ̂ŒӁB
//
// yz
// Ȃ
//
// y߂lz
// >0  I
// <=0   G[
// ------------------------------------------------------------------------------------------------------
PLUGIN_API int Shutdown(void)
{
//	EndHook();
	LOG("Shutdown\n");
	return 1;
}


// ------------------------------------------------------------------------------------------------------
// Stop and Clean up the plugin 
// Return -1 if error
//
// yz
// VKZbVJnɌĂ΂B
// server݂̂viewerł͌Ă΂Ȃ͂B
//
// yz
// Ȃ
//
// y߂lz
// >=0  I
// <0   G[
// ------------------------------------------------------------------------------------------------------
PLUGIN_API int Reset(void)
{
	szExtKey[0] = '\0';

	// f[^ǂݍ
	BOOL ret = PluginReadKeyFile( pKeyData );
	if( !ret ) memset(pKeyData, 0, sizeof(BYTE)*URC4KEYLEN);
	// f[^
	rc4_setup(&rc4Trans, pKeyData, sizeof(pKeyData));
	rc4_setup(&rc4Rest , pKeyData, sizeof(pKeyData));

	LOG("Reset\n");
	return 1;
}


// ------------------------------------------------------------------------------------------------------
// Set the plugin params (Key or password )
// If several params are needed, they can be transmitted separated with ',' (comma)
// then translated if necessary. They also can be taken from the internal Plugin config
// 
// WARNING: The plugin is responsible for implementing necessary GUI or File/Registry reading
// to acquire additionnal parameters and to ensure their persistence if necessary.
// Same thing for events/errors logging.
// 
// This function can be called 2 times, both from vncviewer and WinVNC:
// 
// 1.If the user clicks on the Plugin's "config" button in vncviewer and WinVNC dialog boxes
//   In this case this function is called with hVNC != 0 (CASE 1)
//
//   -> szParams is a string formatted as follow: "Part1,Part2"
//   Part1 = "NoPassword"
//   Part2 = type of application that has loaded the plugin
//     "viewer"     : for vncviewer
//     "server-svc" : for WinVNC run as a service
//     "server-app" : for WINVNC run as an application
//
//   -> The Plugin Config dialog box is displayed if any.
// 
// 2.When then plugin is Inited from VNC viewer or Server, right after Startup() call (CASE 2);
//   In this case, this function is called with hVNC = 0 and
//   szParams is a string formatted as follows: "part1,Part2"
//   Part1 = The VNC password, if required by the GetParams() function return value
//   Part2 = type of application that has loaded the plugin
//      "viewer"     : for vncviewer
//      "server-svc" : for WinVNC run as a service
//      "server-app" : for WINVNC run as an application
//   (this info can be used for application/environnement dependent
//    operations (config saving...))
//   
//
// yz
// vOCɑ΂Đݒǂݍŗ~ɌĂ΂B
// iƂ邲ƂɌĂ΂̂ŋtɎgÂ炢j
//
// hVNCNULL̏ꍇ̓RtBOʂ̌ĂяovłB--- CASE1
// NULL̏ꍇ͂ȊOiڑȂǁjłB              --- CASE2
// 
// szParamśupX[h,Ăяoށv̌`ŕ񂪓ĂB
// pX[hGetParams()"VNCPasswordNeeded"ԂꍇɌ蕽pX[hႦB
// ZbVpX[hŉlpB
// ȊO"NoPassword"BipX[hݒ肳ĂȂƂӖł͂Ȃj
// Ăяoނ"viewer","server-svc","server-app"̂RށB
// ^XNgĆuAdmin Propertiesv̉ʂ"server-svc"B
//
// yz
// hVNC      eEBhE
// szParams  pX[h,Ăяo
//
// y߂lz
// >0  I
// <=0   G[
// ------------------------------------------------------------------------------------------------------
PLUGIN_API int SetParams(HWND hVNC, char* szParams)
{
	char szToken[256]="";
	LOG("SetParams %s\n", szParams);

	strcpy(szToken, szParams);
	char* token = strtok(szToken, ",");
	if( hVNC )
		ShowConfigDialog(hInstance, hVNC, (LPARAM)PLUGIN_DESCRIPTION);
	else
		strcpy(szExtKey, token ? token : "");

	return 1;
}


// ------------------------------------------------------------------------------------------------------
// Return the current plugin params
// As the plugin is basically a blackbox, VNC doesn't need to know 
// the Plugin parameters.
// But we use this method to know if the plugin needs the VNC password
// as a parameter to do its job correctly (for login step).
// Thus this function is called once before the SetParams() function is called
//  - Return "VNCPasswordNeeded" if VNC password must be transmitted by the UltraVNC app
//  - Return any other Plugin parameters value otherwise (not used in WinVNC & vncviewer for now)
//
// yz
// SetParams()ŃpX[hKv
// "VNCPasswordNeeded"ԂSetParams()szParamsɕpX[hႦB
// ȊO͉ȂB
// ̊֐"VNCPasswordNeeded"ԂԂȂłB
//
// Ȃ݂ɌĂяo if( !stricmp("VNCPasswordNeeded",GetParams()) ){...} ƂȂĂB
//
// yz
// Ȃ
//
// y߂lz
// "VNCPasswordNeeded"ȊO̕BNULL͗OɂȂB
// ------------------------------------------------------------------------------------------------------
PLUGIN_API char* GetParams(void)
{
	char* ret="nothing";
//	char* ret="VNCPasswordNeeded";
//	if( szExtKey[0] ) ret = szExtKey;
	LOG("GetParams %s\n", ret);
	return ret;
}

// ------------------------------------------------------------------------------------------------------
// TransformBuffer function
//
// Transform the data given in pDataBuffer then return the pointer on the allocated 
// buffer containing the resulting data.
// The length of the resulting data is given by pnTransformedDataLen
//
//
// yz
// Mf[^encode(,Í)鎞ɌĂ΂B
// KvOCŕʃmۂA֕f[^˂݁Ã|C^ԂƁB
// Ⴆf[^̉H؍sȂꍇłB
// ł̂ł΃TCYĂnjB
//
// yz
// pDataBuffer              Mf[^
// nDataLen                 Mf[^̃TCY
// pnTransformedDataLen     ̃f[^̃TCY
//
// y߂lz
// vOCŊmۂobt@ւ̃|C^
// ------------------------------------------------------------------------------------------------------
PLUGIN_API BYTE* TransformBuffer(BYTE* pDataBuffer, int nDataLen, int* pnTransformedDataLen)
{
	//
	// ɂnDataLen̒lɂȂꍇ
	// serveȓM݂̂ŁAclient̑Mɂ͕ɂ͂ȂȂ
	// ̂܂ܕԂƃT[o[ÎŃ[ɏĕԂƂŋؒf
	// T[o[ʂ}VƂuƂ
	// MSRC4PluginARC4Pluginł炭ČĂ̂Ŗ{̂̕sł͂Ȃ
	// iɂȂĂmF͂łĂȂI͂j
	//
	// mFP[X
	// vista 32bit(server) - xp (viewer) ̊֌WŐڑF،Ab玀
	//
	if( nDataLen < 0 )
	{
		LOG("TransformBuffer %d\n",nDataLen);
		nDataLen = 0;
	}

	// obt@m
	int ret = PluginMallocBuffer(&TransBuffer, nDataLen);
	if( ret < 0 )
	{
		*pnTransformedDataLen = 0;
		return NULL;
	}

	// ϊ
//	for(int i=0; i < nDataLen; i++)
//		TransBuffer.pBuffer[i] = pDataBuffer[i]^0xaa;
	rc4_crypt(&rc4Trans, pDataBuffer, nDataLen, TransBuffer.pBuffer);

	*pnTransformedDataLen = nDataLen;
//	LOG("TransformBuffer\t%d\t%#02x %#02x\n", nDataLen, *pDataBuffer, *TransBuffer.pBuffer);
	return TransBuffer.pBuffer;
}


// ------------------------------------------------------------------------------------------------------
// RestoreBuffer function
//
// This function has a 2 mandatory behaviors:
//
// 1. If pRestoredDataBuffer is NULL, the function must return the pointer to current
//    LocalRestBuffer that is going to receive the Transformed data to restore
//    from VNC viewer/server's socket.
//    This buffer must be of the size of transformed data, calculated from nDataLen
//    and this size must be given back in pnRestoredDataLen.
//
// 2. If pRestoredDataBuffer != NULL, it is the destination buffer that is going to receive
//    the restored data. So the function must restore the data that is currently in the
//    local pLocalRestBuffer (nDataLen long) and put the result in pRestoredDataBuffer.
//    The length of the resulting data is given back in pnTransformedDataLen
//
// Explanation: When VNC viewer/server wants to restore some data, it does the following:
// - Calls RestoreBuffer with NULL to get the buffer (and its length) to store incoming transformed data
// - Reads incoming transformed data from socket directly into the buffer given (and of given length)
// - Calls RestoreBuffer again to actually restore data into the given destination buffer.
// This way the copies of data buffers are reduced to the minimum.
// 
//
// yz
// ₱̂ŃR[hȂǂŉB
//
// Mf[^decode(,Í)鎞ɌĂ΂B
// KvOCŕʃmۂÃ|C^ԂƁB
// Ⴆf[^̉H؍sȂꍇłB
// ̃obt@TCY͕ςȂ̂ŁATCY点Ă₷Ƃ͂łȂB
//
// ̊֐͂QXebvɕČĂяoB
// step1:
//   Mf[^p̃obt@B
//   pRestoredDataBufferNULLŌĂ΂B
//   nDataLenɎMf[^TCYĂ̂ŁAmۂẴ|C^ԂB
//   ̊mۂ̈ɎMf[^̂܂܃Rs[B
//
//   Ȃ݂ɁA
//   'step1nDataLen'  'step2pRestoredDataBuffer' ̃obt@TCYɂȂ
//   'step1pnRestoredDataLenɃZbgl'  'step2nDataLen' ̒lɂȂ
//
// step2:
//   f[^ԂB
//   pRestoredDataBufferɕ̃obt@pAhXnČĂяoB
//   step1ŊmۂɎMf[^Ă̂ŁÃf[^pRestoredDataBufferɓB
//   pRestoredDataBufferstep1Ŋmۂobt@Ƃ͕ʂȂ̂ŁAstep1̃obt@AhX͂ǂɋLĂKv̂ŒӁB
//
// ܂Ƃ߁F
// Mobt@pӂ   ̏ԁB
//
//
// yz
// step1
//   pRestoredDataBuffer      NULLŒ
//   nDataLen                 Kvobt@TCY
//   pnRestoredDataLen        mۂobt@TCY
//
// step2
//   pRestoredDataBuffer      ̃f[^obt@
//   nDataLen                 step1Ŋmۂobt@TCY
//   pnRestoredDataLen        ̃f[^̃TCY
//
// y߂lz
// vOCŊmۂobt@ւ̃|C^
// ------------------------------------------------------------------------------------------------------
PLUGIN_API BYTE* RestoreBuffer(BYTE* pRestoredDataBuffer, int nDataLen, int* pnRestoredDataLen)
{
	// obt@m
	if( pRestoredDataBuffer==NULL )
	{
		*pnRestoredDataLen = nDataLen;
		PluginMallocBuffer(&RestBuffer, nDataLen);
		return RestBuffer.pBuffer;
	}
	// ϊ
//	for(int i=0; i < nDataLen; i++)
//		pRestoredDataBuffer[i] = RestBuffer.pBuffer[i]^0xaa;
	rc4_crypt(&rc4Rest, RestBuffer.pBuffer, nDataLen, pRestoredDataBuffer);

	*pnRestoredDataLen = nDataLen;
//	LOG("RestoreBuffer\t%d\t%#02x %#02x\n", nDataLen, *RestBuffer.pBuffer, *pRestoredDataBuffer);
	return RestBuffer.pBuffer;
}


// ------------------------------------------------------------------------------------------------------
// Free the DataBuffer and TransBuffer than have been allocated
// in TransformBuffer and RestoreBuffer, using the method adapted
// to the used allocation method.
//
//
// yz
// TransformBuffer()yRestoreBuffer()ŃvOCmۂobt@̊JB
// viewer̓ZbVIAserver̓T[o[Iɂ̂݌Ă΂B
// Q̊֐łꂼobt@mۂĂ΂QĂ΂B
//
// ###
// Ȃ݂servervOC̓ZbVIƂm邱ƂoȂ̂ŁA
// ڑȂԂłȑOmۂƊmۂςȂɂȂB
// CreatePluginInterface()ɑΉ΁A̓ZbVƂɊmہAJB
// ###
//
// yz
// pBuffer      vOCŊmۂobt@̃AhX
//
// y߂lz
// Ȃ
// ------------------------------------------------------------------------------------------------------
PLUGIN_API void FreeBuffer(BYTE* pBuffer)
{
	if( pBuffer == TransBuffer.pBuffer ) TransBuffer.pBuffer = NULL;
	if( pBuffer == RestBuffer.pBuffer ) RestBuffer.pBuffer = NULL;
	delete [] pBuffer;
	LOG("FreeBuffer\n");
	return;
}


// ------------------------------------------------------------------------------------------------------
//
// yz
// VKnewIPluginC^[tF[XԂ܂B
// vOC̊֐ɑΉĂvnc{̂}`Xbhœ삵܂BZLAȓڑ\ɂȂ
// ̊֐GNX|[gȂorNULLԂƓڑ͂łȂȂ悤łBivOCŃZbṼǗłȂׂ̑[uƎvj
// AA̋@\2009-06-21ȍ~̃o[WL̂悤łB
//
// IPluginԂTransformBuffer()RestoreBuffer()̑ւɁA
// IPlugin::TransformBuffer()IPlugin::RestoreBuffer()Ă΂悤ɂȂ܂B
// ܂Aȉ̊֐͌Ă΂ȂȂ܂B
// TransformBuffer() RestoreBuffer() FreeBuffer()
// 
// server,viewerɃZbVJnƂɌĂ΂܂B
// ܂AZbVIɌĂяodeleteĂ̂ŁAvOCŃ̊Ǘ͕Kv܂B
// Ăяo鏇ԁF
// Startup()  CreatePluginInterface()  new IPlugin  Reset()  <transfer>  delete IPlugin  Shutdown()
// Shutdown()̑OdeletêŒ
// serverReset()͍ŏ̈lڂ̃ZbVJn݂̂łBQlڈȍ~͌Ă΂܂B
// viewerłReset()͌Ă΂܂B
//
// IuWFNg̏Kvȏꍇ̓RXgN^ōsKv܂B
// IuWFNgmۂ͕KfXgN^ŊJĂBFreeBuffer()͌Ăяo܂B
//
// yz
// Ȃ
//
// y߂lz
// newIPlugin
// ------------------------------------------------------------------------------------------------------
PLUGIN_API IPlugin* CreatePluginInterface(void)
{
	LOG("CreatePluginInterface\n");
	return new IUltraRC4Plugin( pKeyData );
}

// -----------------------------------------------------------------
// End of functions that must be exported
// -----------------------------------------------------------------
 





// ------------------------------------------------------------------------------------------------------
// obt@̊m
//
// :
//  pPlgBuffer   obt@\
//  nNewSize     VTCY
//
// ߂l: mی̃obt@TCY
// ------------------------------------------------------------------------------------------------------
int PluginMallocBuffer(PLGBUFFER* pPlgBuffer, int nNewSize)
{
	if( pPlgBuffer==NULL ) return 0;

	BYTE* pBuffer = pPlgBuffer->pBuffer;
	int nSize = pPlgBuffer->nSize;

	// obt@΍Ċm
	if( nSize < nNewSize )
	{
		// VKm
		nSize = nNewSize;
		delete [] pBuffer;
		memset(pPlgBuffer, 0, sizeof(PLGBUFFER));
		pBuffer = new BYTE [ nSize+1 ];
		if( pBuffer==NULL ) return 0;

		pPlgBuffer->pBuffer = pBuffer;
		pPlgBuffer->nSize   = nSize;
	}

//	memset(pBuffer, 0, nSize);
	return nSize;
}


// ------------------------------------------------------------------------------------------------------
// t@Cǂݍ
//
// :
//  pBuffer   obt@( URC4KELENmۂĂ )
//
// ߂l: ǂݍ߂
// ------------------------------------------------------------------------------------------------------
static BOOL PluginReadKeyFile(BYTE* pBuffer)
{
	FILE* fp = fopen(szKeyFile, "rb");
	if( !fp ) return FALSE;
	fread(pBuffer, sizeof(BYTE), URC4KEYLEN, fp);
	fclose( fp );
	return TRUE;
}






// ------------------------------------------------------------------------------------------------------
// DLL Main Entry point  
// ------------------------------------------------------------------------------------------------------
BOOL WINAPI DllMain(HINSTANCE hInst, DWORD dwReason, LPVOID lpReserved)
{
	switch (dwReason)
	{
	case DLL_PROCESS_ATTACH:
		hInstance = hInst;
		// W[̏ꏊ擾 ( shell APIgp )
		// JgςĂΉł悤
		GetModuleFileName(hInstance, szCurDir, sizeof(szCurDir));
		PathRemoveFileSpec( szCurDir );
		PathAddBackslash( szCurDir );
		sprintf(szLogFile, "%sUltraRC4Plugin.log", szCurDir);
		sprintf(szKeyFile, "%s%s", szCurDir, URC4KEY);

		LOG("DLL_PROCESS_ATTACH ModDir=%s\n", szCurDir);
		break;
	case DLL_THREAD_ATTACH:
		//LOG("DLL_THREAD_ATTACH\n");
		break;
	case DLL_THREAD_DETACH:
		//LOG("DLL_THREAD_DETACH\n");
		break;
	case DLL_PROCESS_DETACH:
		delete [] TransBuffer.pBuffer;
		delete [] RestBuffer.pBuffer;
		LOG("DLL_PROCESS_DETACH %p %p\n", TransBuffer.pBuffer, RestBuffer.pBuffer);
		break;
    }
    return TRUE;
}

